%[if %( %( "%id=nh_charts_dataFile%" != "" )% || %( "%id=nh_charts_defaultChartType%" == "MeterGaugeRenderer" )% )% ]%

// A function to get CSV data and convert it to the JSON format jqPlot requires
var csvRows = []; var objArr = [];
function parseCSVLine (line)
{
	line = line.split(',');
	// check for splits performed inside quoted strings and correct if needed
	for (var i = 0; i < line.length; i++)
	{
		var chunk = line[i].replace(/^[\s]*|[\s]*$/g, "");
		var quote = "";
		if (chunk.charAt(0) == '"' || chunk.charAt(0) == "'") quote = chunk.charAt(0);
		if (quote != "" && chunk.charAt(chunk.length - 1) == quote) quote = "";
		
		if (quote != "")
		{
			var j = i + 1;
			if (j < line.length) chunk = line[j].replace(/^[\s]*|[\s]*$/g, "");
			while (j < line.length && chunk.charAt(chunk.length - 1) != quote)
			{ line[i] += ',' + line[j]; line.splice(j, 1); chunk = line[j].replace(/[\s]*$/g, ""); }
			if (j < line.length)
			{ line[i] += ',' + line[j];line.splice(j, 1); }
		}
	}
	for (var i = 0; i < line.length; i++)
	{
		// remove leading/trailing whitespace
		line[i] = line[i].replace(/^[\s]*|[\s]*$/g, "");
		// remove leading/trailing quotes
		if (line[i].charAt(0) == '"') line[i] = line[i].replace(/^"|"$/g, "");
		else if (line[i].charAt(0) == "'") line[i] = line[i].replace(/^'|'$/g, "");
	}
	//console.log(line);
	return line;
}

function csvToJqPlot (csvData)
{
	var csvText = csvData;
	var jqPlotData = null;
    var labels = [], ticks = [], series1 = [], series2 = [], series3 = [], series4 = [], series5 = [];
    var numOfSeries = 1, temp1, temp2, temp3, temp4, temp5;
	var csvLines = csvText.split(/[\r\n]/g); // split into rows
	for (var i = 0, l=csvLines.length; i < l; i++)
	{
		var csvLine;
		csvLine = parseCSVLine(csvLines[i]);
        if (csvLine.length > 1) {
            if (i === 0) {
              numOfSeries = csvLine.length-1;
              labels.push(csvLine[1]);
            } 
              //temp1 = series1[series1.length-1];
              // make a copy of temp
              //temp1 = temp1.slice(0, temp1.length);
              //for (var n=0, nl=temp1.length; n<nl; n++) { series1[series1.length-1][n] = parseFloat(temp1[n]); }
              switch(csvLine.length) {
	              //The first column is used as ticks for the chart, subsequent columns are the actual values
	              case 2:
	              	if ( i !== 0 ) { ticks.push(csvLine[0]); series1.push(csvLine[1]); }
	              	break;
	              case 3:
	              	if ( i !== 0 ) { ticks.push(csvLine[0]); series1.push(csvLine[1]); series2.push(csvLine[2]); }
	              	else { labels.push(csvLine[2]); }
	              	break;
	              case 4:
	              	if ( i !== 0 ) { ticks.push(csvLine[0]); series1.push(csvLine[1]); series2.push(csvLine[2]); series3.push(csvLine[3]); }
	              	else { labels.push(csvLine[2]); labels.push(csvLine[3]); }
	              	break;
	              case 5:
	              	if ( i !== 0 ) { ticks.push(csvLine[0]); series1.push(csvLine[1]); series2.push(csvLine[2]); series3.push(csvLine[3]); series4.push(csvLine[4]); }
	              	else { labels.push(csvLine[2]); labels.push(csvLine[3]); labels.push(csvLine[4]); }
	              	break;
	              case 6:
	              	if ( i !== 0 ) { ticks.push(csvLine[0]); series1.push(csvLine[1]); series2.push(csvLine[2]); series3.push(csvLine[3]); series4.push(csvLine[4]); series5.push(csvLine[5]); }
	              	else { labels.push(csvLine[2]); labels.push(csvLine[3]); labels.push(csvLine[4]); labels.push(csvLine[5]); }
	              	break;
             }
        }        
	}
	series1 = series1.map(Number);
    series2 = series2.map(Number);
    series3 = series3.map(Number);
    series4 = series4.map(Number);
    series5 = series5.map(Number);
	jqPlotData = [numOfSeries, ticks, labels, series1, series2, series3, series4, series5];
	return jqPlotData;
}


$(document).ready(function(){
	var ieException = false;
	%[if %( "%id=nh_charts_dataFile%" != "" )% ]%
	var chartData, seriesType, fileURL, chartTicks, chartLabels, parseByJs = null;
	var plotData = [], numOfSeries = 0;
	seriesType = %[if %( "%id=nh_charts_displayMultipleSeries%" == "true" )% ]%'multiple'%[else]%'single'%[endif]%;
	fileURL = %[if %( "%id=nh_charts_dataFileURLType%" == "rwResource" )% ]%'%rapidweaverAssetPath%/%id=nh_charts_dataFile%'%[else]%'%id=nh_charts_dataFile%'%[endif]%;
	$.ajax({
		async:false,
		url:'%assetPath%/chartsFunctions.php?action=parseCSVfile&fileURL='+fileURL+'&urlType=%id=nh_charts_dataFileURLType%',
		dataType:'json',
		success:function(data){ chartData = data; },
		error:function(){ %[if %( "%id=nh_charts_dataFileURLType%" != "absoluteURL" )% ]%if ( $.browser.msie && ( parseInt($.browser.version) < 9 ) ) { ieException = true; } else { $.ajax({ async:false, url:fileURL, dataType:"text", success:function(data){ chartData = csvToJqPlot(data); parsedByJs = true; } }); }%[endif]% }
	});
	if ( !ieException ) {
		numOfSeries = seriesType == 'multiple' ? chartData[0] : 1 ;
		switch(numOfSeries) {
			case 1: plotData = [chartData[3]]; break;
			case 2: plotData = [chartData[3],chartData[4]]; break;
			case 3: plotData = [chartData[3],chartData[4],chartData[5]]; break;
			case 4: plotData = [chartData[3],chartData[4],chartData[5],chartData[6]]; break;
			case 5: plotData = [chartData[3],chartData[4],chartData[5],chartData[6],chartData[7]]; break;
			case 6: plotData = [chartData[3],chartData[4],chartData[5],chartData[6],chartData[7],chartData[8]];	break;
			case 7: plotData = [chartData[3],chartData[4],chartData[5],chartData[6],chartData[7],chartData[8],chartData[9]]; break;
			case 8: plotData = [chartData[3],chartData[4],chartData[5],chartData[6],chartData[7],chartData[8],chartData[9],chartData[10]]; break;
			case 9: plotData = [chartData[3],chartData[4],chartData[5],chartData[6],chartData[7],chartData[8],chartData[9],chartData[10],chartData[11]]; break;
			case 10: plotData = [chartData[3],chartData[4],chartData[5],chartData[6],chartData[7],chartData[8],chartData[9],chartData[10],chartData[11],chartData[12]]; break;
		}
		chartTicks = chartData[1];
		chartLabels = chartData[2];
		//console.log(plotData);
	}
	%[endif]%
	if ( !ieException || ( ( "%id=nh_charts_defaultChartType%" == "MeterGaugeRenderer" ) && ( "%id=nh_charts_dataFile%" == "" ) ) ) {
		$('#nimblehost_charts_%id%').jqplot(
			%[if %( %( "%id=nh_charts_defaultChartType%" == "MeterGaugeRenderer" )% && %( "%id=nh_charts_dataFile%" == "" )% )% ]%[[%id=nh_charts_meterGaugeMeasured%]]%[else]%plotData%[endif]%,
			{
				animate: %id=nh_charts_animateChart%,
				title: '%id=nh_charts_chartTitle%',
				legend: { show: %id=nh_charts_showLegend%, %[if %( "%id=nh_charts_dataFile%" != "" )% ]%labels: %[if %( %( "%id=nh_charts_defaultChartType%" == "DonutRenderer" )% || %( "%id=nh_charts_defaultChartType%" == "PieRenderer" )% )% ]%chartTicks%[else]%chartLabels%[endif]%,%[endif]% textColor: '%id=nh_charts_legendTextAndBorderColor%', location: '%id=nh_charts_legendLocation%', xoffset: %id=nh_charts_legendXoffset%, yoffset: %id=nh_charts_legendYoffset% },
				%[if %( %( "%id=nh_charts_stackSeries%" == "true" )% && %( "%id=nh_charts_defaultChartType%" == "BarRenderer" )% )% ]%stackSeries: true,%[endif]%
				seriesDefaults:{
		            renderer:$.jqplot.%id=nh_charts_defaultChartType%,
		            rendererOptions: {
		            	padding: %id=nh_charts_chartPadding%,
		            	%[if %( "%id=nh_charts_defaultChartType%" == "BarRenderer" )% ]%/* Bar Chart Otions */ varyBarColor: %[if %( "%id=nh_charts_varyBarColor%" == "true" )% ]%true%[else]%false%[endif]%, fillToZero: %[if %( "%id=nh_charts_displayNegativeBarsBelowZero%" == "true" )% ]%true%[else]%false%[endif]%,%[endif]%
	            		%[if %( "%id=nh_charts_defaultChartType%" == "DonutRenderer" )% ]%/* Donut Chart Options */ fill: %id=nh_charts_donutSliceFilled%, sliceMargin: %id=nh_charts_donutSliceMargin%,%[endif]%
	            		%[if %( "%id=nh_charts_defaultChartType%" == "LineRenderer" )% ]%/* Line Chart Options */ smooth: %id=nh_charts_lineSmoothing%,%[endif]%
	            		%[if %( "%id=nh_charts_defaultChartType%" == "PieRenderer" )% ]%/* Pie Chart Options */ fill: %id=nh_charts_pieSliceFilled%,%[if %( "%id=nh_charts_pieSliceFilled%" == "false" )% ]%lineWidth:%id=nh_charts_pieSliceLineWidth%,%[endif]%sliceMargin: %id=nh_charts_pieSliceMargin%,%[endif]%
	            		%[if %( "%id=nh_charts_defaultChartType%" == "MeterGaugeRenderer" )% ]%/* Meter Gauge Options */ ringColor: '%id=nh_charts_meterGaugeRingColor%', background:'%id=nh_charts_meterGaugeBackgroundColor%', min: %id=nh_charts_meterGaugeMin%, max: %id=nh_charts_meterGaugeMax%, %[if %( "%id=nh_charts_meterGaugeIntervals%" != "" )% ]%intervals: [%id=nh_charts_meterGaugeIntervals%,%id=nh_charts_meterGaugeMax%], %[endif]%label: '%id=nh_charts_meterGaugeLabel%', intervalColors: ['%id=nh_charts_dataSet1Color%','%id=nh_charts_dataSet2Color%','%id=nh_charts_dataSet3Color%','%id=nh_charts_dataSet4Color%','%id=nh_charts_dataSet5Color%','%id=nh_charts_dataSet6Color%','%id=nh_charts_dataSet7Color%','%id=nh_charts_dataSet8Color%','%id=nh_charts_dataSet9Color%','%id=nh_charts_dataSet10Color%','%id=nh_charts_dataSet11Color%','%id=nh_charts_dataSet12Color%','%id=nh_charts_dataSet13Color%','%id=nh_charts_dataSet14Color%','%id=nh_charts_dataSet15Color%','%id=nh_charts_dataSet16Color%','%id=nh_charts_dataSet17Color%','%id=nh_charts_dataSet18Color%','%id=nh_charts_dataSet19Color%','%id=nh_charts_dataSet20Color%'],%[endif]%
	            		showDataLabels: %id=nh_charts_showDataLabels%
		            },
		            useNegativeColors: %[if %( "%id=nh_charts_useNegativeSeriesColors%" == "true" )% ]%true%[else]%false%[endif]%
		            %[if %( %( "%id=nh_charts_defaultChartType%" == "LineRenderer" )% && %( "%id=nh_charts_linePointStyle%" == "none" )% )% ]%, showMarker: false%[endif]%
		            %[if %( %( "%id=nh_charts_displayBarPointLabels%" == "true" )% || %( "%id=nh_charts_displayLinePointLabels%" == "true" )% )% ]%, pointLabels: { show: true }%[endif]%
		            %[if %( "%id=nh_charts_defaultChartType%" == "LineRenderer" )% ]%, showLine: %id=nh_charts_lineHide%, linePattern: '%id=nh_charts_lineStyle%', markerOptions: { style: '%id=nh_charts_linePointStyle%' }%[endif]%
		        },
		        seriesColors: ['%id=nh_charts_dataSet1Color%','%id=nh_charts_dataSet2Color%','%id=nh_charts_dataSet3Color%','%id=nh_charts_dataSet4Color%','%id=nh_charts_dataSet5Color%','%id=nh_charts_dataSet6Color%','%id=nh_charts_dataSet7Color%','%id=nh_charts_dataSet8Color%','%id=nh_charts_dataSet9Color%','%id=nh_charts_dataSet10Color%','%id=nh_charts_dataSet11Color%','%id=nh_charts_dataSet12Color%','%id=nh_charts_dataSet13Color%','%id=nh_charts_dataSet14Color%','%id=nh_charts_dataSet15Color%','%id=nh_charts_dataSet16Color%','%id=nh_charts_dataSet17Color%','%id=nh_charts_dataSet18Color%','%id=nh_charts_dataSet19Color%','%id=nh_charts_dataSet20Color%'],
		        negativeSeriesColors: ['%id=nh_charts_negativeSeries1Color%','%id=nh_charts_negativeSeries2Color%','%id=nh_charts_negativeSeries3Color%','%id=nh_charts_negativeSeries4Color%','%id=nh_charts_negativeSeries5Color%','%id=nh_charts_negativeSeries6Color%','%id=nh_charts_negativeSeries7Color%','%id=nh_charts_negativeSeries8Color%','%id=nh_charts_negativeSeries9Color%','%id=nh_charts_negativeSeries10Color%','%id=nh_charts_negativeSeries11Color%','%id=nh_charts_negativeSeries12Color%','%id=nh_charts_negativeSeries13Color%','%id=nh_charts_negativeSeries14Color%','%id=nh_charts_negativeSeries15Color%','%id=nh_charts_negativeSeries16Color%','%id=nh_charts_negativeSeries17Color%','%id=nh_charts_negativeSeries18Color%','%id=nh_charts_negativeSeries19Color%','%id=nh_charts_negativeSeries20Color%'],
		        axesDefaults: { tickRenderer: $.jqplot.CanvasAxisTickRenderer, tickOptions: { textColor: %[if %( "%id=nh_charts_defaultChartType%" == "MeterGaugeRenderer" )% ]%"transparent"%[else]%"%id=nh_charts_axisColor%"%[endif]% } },
		        axes:{
		            xaxis:{ renderer: $.jqplot.CategoryAxisRenderer, label: "%id=nh_charts_xAxisLabel%", labelRenderer: $.jqplot.CanvasAxisLabelRenderer, labelOptions: { textColor: '%id=nh_charts_axisLabelColor%' }, %[if %( "%id=nh_charts_dataFile%" != "" )% ]%ticks: chartTicks,%[endif]% tickOptions: { %[if %("%id=nh_charts_angleXAxisTicks%" == "true")% ]%angle: %id=nh_charts_xAxisAngle%, %[endif]%showGridline: %[if %( "%id=nh_charts_xGridLineHide%" == "true" )% ]%false%[else]%true%[endif]%, showMark: false } },
		            yaxis:{ label: '%id=nh_charts_yAxisLabel%', labelRenderer: $.jqplot.CanvasAxisLabelRenderer, labelOptions: { textColor: '%id=nh_charts_axisLabelColor%' }, tickOptions: { showGridline: %[if %( "%id=nh_charts_yGridLineHide%" == "true" )% ]%false%[else]%true%[endif]%, showMark: false } }
	            },
		        grid: { backgroundColor: %[if %( "%id=nh_charts_gridTransparentBackground%" == "transparent" )% ]%'transparent'%[else]%'%id=nh_charts_gridBackgroundColor%'%[endif]%, gridLineColor: %[if %( "%id=nh_charts_gridLineWidth%" == "0" )% ]%'transparent'%[else]%'%id=nh_charts_gridLineColor%'%[endif]%, gridLineWidth: %id=nh_charts_gridLineWidth%, borderColor: "%id=nh_charts_gridBorderColor%", borderWidth: '%id=nh_charts_gridBorderWidth%', shadowAlpha: %[if %( "%id=nh_charts_gridBorderWidth%" == "0" )% ]%0.00%[else]%0.07%[endif]% }
			}
		);
	} else { $('#nimblehost_charts_%id%').prepend('<p>Your web browser is unable to display the chart for this section. Please upgrade your browser to the latest version.</p>'); }
});
%[endif]%